> For new integrations, EasyParcel recommends the NextGen API: https://developer.easyparcel.com/

# Making Order Payment

> EasyParcel API · Malaysia · Individual · version 1.4.0.0
> Page: https://developers.easyparcel.com/my/individual/making-order-payment · Markdown: https://developers.easyparcel.com/my/individual/making-order-payment.md · PDF: https://developers.easyparcel.com/pdf/Malaysia_Individual_1.4.0.0.pdf

This step involves payment for the orders made. The authenticated user can do single order payment. Single order payment refers to payment for a single parcel only. There are various payment conditions that may appear such as insufficient credit (when user’s account do not have sufficient credit to perfom payment), sufficient credit (when there are sufficient credit for payment) and etc.

## Endpoint

- Method: `POST`
- Demo URL: `http://demo.connect.easyparcel.my/?ac=EPPayOrderBulk`
- Live URL: `https://connect.easyparcel.my/?ac=EPPayOrderBulk`
- Body: `application/x-www-form-urlencoded`. Nested fields use PHP `http_build_query` names, e.g. `bulk[0][pick_code]`.
- Action: `EPPayOrderBulk`

## Request parameters

### Request L1

| Parameter | Type | Required | Description |
| --- | --- | --- | --- |
| `api` | string(25) | Yes | Obtain from registered account. |
| `bulk` | array | Yes | (Refer to [Request L2](#request-l2)) |
| `auto_apply_coupon` | boolean | Optional | Controls whether eligible coupons are automatically applied for the shipment. If this parameter is not specified, the behavior will follow the auto-apply coupon settings configured in EasyParcel. |

### Request L2 · `bulk[]` {#request-l2}

| Parameter | Type | Required | Description |
| --- | --- | --- | --- |
| `order_no` | string(15) | Yes | Acquire from the order that placed. |

## Sample code

### PHP

```php
<?php
$domain = "https://demo.connect.easyparcel.my/?ac=";

$action = "EPPayOrderBulk";
$postparam = array(
    'api' => 'xxxxxx',
    'bulk' => array(
        array(
            'order_no' => 'EI-5UFAI',
        ),
    ),
);

$url = $domain.$action;
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postparam));
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

ob_start();
$return = curl_exec($ch);
ob_end_clean();
curl_close($ch);

$json = json_decode($return);
echo "<pre>"; print_r($json); echo "</pre>";
?>
```

### cURL

```bash
curl -X POST 'https://demo.connect.easyparcel.my/?ac=EPPayOrderBulk' \
  --data-urlencode 'api=xxxxxx' \
  --data-urlencode 'bulk[0][order_no]=EI-5UFAI'
```

## Response

### Response L1

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `api_status` | string(10) | Validation result | (Refer to [Appendix I](https://developers.easyparcel.com/my/individual/appendix/api-return-status.md)) |
| `error_code` | int(5) | Error code | (Refer to [Appendix I](https://developers.easyparcel.com/my/individual/appendix/api-return-status.md)) |
| `error_remark` | string(100) | Error message | (Refer to [Appendix I](https://developers.easyparcel.com/my/individual/appendix/api-return-status.md)) |
| `result` | array | The response of the make order payment | (Refer to [Response L2](#response-l2)) |

### Response L2 · `result` {#response-l2}

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `orderno` | string(15) | Valid order number. | Valid and authenticated. |
| `messagenow` | string(50) | The message that shows the status of order. |  |
| `parcel` | array | The details of the parcel. | (Refer to [Response L3](#response-l3)) |

### Response L3 · `parcel` {#response-l3}

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `parcelno` | string (15) | Parcel number. |  |
| `awb` | string (45) | Airway bill number. |  |
| `awb_id_link` | string (300) | PDF link of Airway bill number. |  |
| `tracking_url` | string (300) | Link of tracking url. |  |

## Response samples

### Success

```json
{
  "api_status":"Success",
  "error_code":"0",
  "error_remark":"",
  "result":[
    {
      "orderno":"EI-5UFAI",
      "messagenow":"Fully Paid",
      "parcel":[
        {
          "parcelno":"EP-PQKTE",
          "awb":"238770015234",
          "awb_id_link":"http:\/\/demo.connect.easyparcel.my\/?ac=AWBLabel&id=QmIxTE43eHQjMTYzMDQwMTI%3D",
          "tracking_url":"https:\/\/easyparcel.com\/my\/en\/track\/details\/?courier=Skynet&awb=238770015234"
        }
      ]
    }
  ]
}
```

### Fail

```json
{
    "api_status": "Success",
    "error_code": "0",
    "error_remark": "",
    "result": [
        {
            "orderno": "EI-5UFAI",
            "messagenow": "Insufficient Credit",
            "parcel": [
                {}
            ]
        }
    ]
}
```

## Referenced appendices

Copied from the appendix pages linked above.

### Appendix I: API Return Status

Source: https://developers.easyparcel.com/my/individual/appendix/api-return-status.md

| api_status | error_code | error_remark | Explanation |
| --- | --- | --- | --- |
| Success | 0 |  |  |
| Error | 1 | Required authentication key | Missing authentication param |
| Error | 2 | Invalid authentication key |  |
| Error | 3 | Required api key | Missing API key param |
| Error | 4 | Invalid api key |  |
| Error | 5 | Unauthorized user | Invalid API key |
| Error | 6 | Required bulk array |  |
| Error | 7 | Required bulk data insert format in array |  |
| Error | 8 | Invalid account |  |
| Error | 9 | Unverified account. Please kindly verify your account at easyparcel.com |  |
| Error | 1000 | Missing / Invalid Parameter | If a required parameter is missing or an invalid value is entered, the error will be displayed in the error_detail field. |
| Error | 1002 | Invalid User Account | The user does not have a wallet associated with the relevant country. |
| Error | 1003 | Invalid parcel category, you should refer to Get Parcel Category API | Invalid parcel category, you should refer to Get Parcel Category API |
| Error | 1004 | Invalid collection/ delivery postcode |  |
| Error | 1005 | Invalid collection/delivery state | If the value is "Pulau Penang," an error will occur because our system only accepts state codes. |
| Error | 1006 | Invalid courier | Incorrect Courier code |
| Error | 3001 | Shipment insured | This tracking number has previously purchased insurance through EasyParcel, cannot buy insurance again |
| Error | 3002 | Shipment delivered | The status of this tracking number shipment is "delivered", not allow to buy insurance |
| Error | 3003 | Not under claim coverage | The courier insurance provides coverage for parcel contents up to RM200. However, since you entered a parcel content value of RM100, it does not qualify for claim coverage. |
| Error | 3004 | Only support international/domestic shipment | For example, Fedex only supports international shipments to buy insurance |
| Error | 3005 | No Cover | If the collection state or delivery location is not within the insurance coverage area, an error message along with a description will be displayed. |
| Error | 9999 | Unknown error | If this error occurs, please contact our support team for assistance. |

Support: WhatsApp EasyParcel API Support — https://api.whatsapp.com/send/?phone=6042023160

Published by EasyParcel Sdn Bhd (1028666-H).
